/*****************************************************************************
 *
 * object_users - encapsulations of the users for use of CGI code
 *
 * Copyright (c) 2004 Ben Clewett (bclewett@perfparse.org)
 * Last Modified:   2004-12-31
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include "perfgraph.h"
#include <libpp_common.h>
#include <config.h>
#include <gettext.h>
#include "object_users.h"

TUsers user;

/* Populate user details */
void getUser()
{

	user.sUserName = getenv("REMOTE_USER");

	if (!user.sUserName) user.sUserName = "DEFAULT";

	g_string_printf(s_SQL, "SELECT group_name, raw_show_normal, raw_show_warning, raw_show_critical, raw_show_unknown, raw_refresh_time FROM perfdata_users WHERE user_name = '%s'",
		sql_escape(user.sUserName, PERCENT_ESCAPE_CHAR));

	query(s_SQL->str);

	#ifdef USE_DB_MYSQL
	result_row = mysql_fetch_row(query_result);
	if (!result_row) {
	#elif defined USE_DB_POSTGRESQL
	currentRow = 0;
	if (rows()<=0) {
	#endif

		/* New User */
		user.sGroupName = "";
		user.bRawShowNormal = TRUE;
		user.bRawShowWarning = TRUE;
		user.bRawShowCritical = TRUE;
		user.bRawShowUnknown = TRUE;
		user.iRawRefreshTime = 0;

		g_string_printf(s_SQL, "INSERT INTO perfdata_users (user_name, group_name) VALUES ('%s'",
			sql_escape(user.sUserName, PERCENT_ESCAPE_CHAR));
		g_string_append_printf(s_SQL, ",'%s')",
			sql_escape(user.sGroupName, PERCENT_ESCAPE_CHAR));
		query_no_return(s_SQL->str);

	}

	else {

		user.sGroupName = strdup(sData(0));
		#ifdef USE_DB_MYSQL
		user.bRawShowNormal = iData(1);
		user.bRawShowWarning = iData(2);
		user.bRawShowCritical = iData(3);
		user.bRawShowUnknown = iData(4);
		#elif defined USE_DB_POSTGRESQL
		user.bRawShowNormal = bData(1);
		user.bRawShowWarning = bData(2);
		user.bRawShowCritical = bData(3);
		user.bRawShowUnknown = bData(4);
		#endif
		user.iRawRefreshTime = iData(5);

	}

}


void saveUser()
{
	/* Assumption:- User already exists. */

	#ifdef USE_DB_MYSQL
	g_string_printf(s_SQL, "UPDATE perfdata_users SET group_name = '%s'",
		sql_escape(user.sGroupName, PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, ", raw_show_normal = %d, raw_show_warning = %d, raw_show_critical = %d, raw_show_unknown = %d, raw_refresh_time = %d",
		user.bRawShowNormal, user.bRawShowWarning, user.bRawShowCritical, user.bRawShowUnknown, user.iRawRefreshTime);
	g_string_append_printf(s_SQL, " WHERE user_name = '%s'",
		sql_escape(user.sUserName, PERCENT_ESCAPE_CHAR));
	#elif defined USE_DB_POSTGRESQL
	g_string_printf(s_SQL, "UPDATE perfdata_users SET group_name = '%s'",
		sql_escape(user.sGroupName, PERCENT_ESCAPE_CHAR));
	g_string_append_printf(s_SQL, ", raw_show_normal = %s, raw_show_warning = %s, raw_show_critical = %s, raw_show_unknown = %s, raw_refresh_time = %d",
		user.bRawShowNormal ? "TRUE" : "FALSE", user.bRawShowWarning ? "TRUE" : "FALSE", 
		user.bRawShowCritical ? "TRUE" : "FALSE", user.bRawShowUnknown ? "TRUE" : "FALSE", user.iRawRefreshTime);
	g_string_append_printf(s_SQL, " WHERE user_name = '%s'",
		sql_escape(user.sUserName, PERCENT_ESCAPE_CHAR));
	#endif

	query_no_return(s_SQL->str);


}


