/*****************************************************************************
 *
 * common.c - Common functions required by PerfParse suit.
 *
 * Copyright (c) 2004 Ben Clewett (perfparse@clewett.org.uk)
 * Last Modified:   2004-05-28
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <glib.h>
#include "libpp_common.h"
#include "common.h"
#include <netdb.h>
#include <config.h>
#include <gettext.h>

#undef SHOW_SQL

/* States */
char *sStates[4] = { "UP", "WARNING", "CRITICAL", "UNKNOWN" };
char *sStateColour[4] = { "FFFFFF", "FFFF00", "FF8888", "FF8844" };



/***************************************
 *
 * Hash
 *
 ***************************************/


char *s_hash(const char *name)
{
	static char sOut[20];
	sprintf(sOut, "%08lX", (unsigned long)hash(name));
	return sOut;
}
unsigned long hash(const char *name)
{
    unsigned long   h = 0, g;
    static int M = HASHSIZE;

    while (*name)
        {
        h = ( h << 4 ) + *name++;
/* Original line for below (YM 20040611):
        if (g = h & 0xF0000000L)
*/
        if ((g = (h & 0xF0000000L)))
            h ^= g >> 24;

        h &= ~g;
        }
    return h % M;
}

