/*****************************************************************************
 *
 * libstorage.c - Parse Nagios data and store in relational database.
 *
 * Copyright (c) 2004 Yves Mettier (ymettier@libertysurf.fr)
 * Last Modified:   2004-09-01
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpp_storage.h"

#include <config.h>
#include <gettext.h>

storage_module_t *storage_new(const char*id, const char*version) {
	storage_module_t *sm_new;
	sm_new = malloc(sizeof(storage_module_t));
	if(NULL == sm_new) return(NULL);
	strncpy(sm_new->id,id,30);
	strncpy(sm_new->version,version,10);
	sm_new->params = NULL;
	sm_new->enabled = 0;
	sm_new->store_line = NULL;
	sm_new->set_registry = NULL;
	sm_new->store_perf_values = NULL;
	sm_new->connect = NULL;
	sm_new->disconnect = NULL;
	sm_new->atexit = NULL;
	sm_new->print_statistics = NULL;
	sm_new->print_usage = NULL;
	sm_new->periodic_cleanup = NULL;

	sm_new->log = NULL;
	return(sm_new);
}
